#include "common.h"
#include "comm.h"
#include "../util.h"
#include "../resource.h"

CCommManager::CCommManager()
{
}

CCommManager::~CCommManager()
{
	Finish();
}

CCommManager& CCommManager::GetInstance()
{
	static CCommManager Singleton;
	return Singleton;
}


//
bool CCommManager::Init()
{
	Finish();

	//ݒt@C̃pX擾
	TCHAR IniPath[_MAX_PATH+1]={0};
	GetModuleFileName(NULL,IniPath,_MAX_PATH);
	PathRemoveFileSpec(IniPath);
	PathAppend(IniPath,_T("Config.ini"));

	//--------------
	// ݒǂݍ
	//--------------
	//v|[g
	const int iRequire=GetPrivateProfileInt(_T("Common"),_T("Require"),1,IniPath);
	if(iRequire<0){	//Require=0̓R}ĥ
		UtilErrorMessage(NULL,CString(MAKEINTRESOURCE(IDS_ERROR_PORTCOUNT)));
		Finish();
		return false;
	}
	//|[gm
	//v|[g̃|[gݒmF
	for(int i=0;i<iRequire;i++){
		m_PortArray.push_back(new CCommPort());
		CString strSectionName;
		strSectionName.Format(_T("Port%d"),i);
		CString strDefPortName;
		strDefPortName.Format(_T("COM%d"),i+1);

		//|[g
		TCHAR szPortName[_MAX_PATH+1]={0};
		GetPrivateProfileString(strSectionName,_T("Device"),strDefPortName,szPortName,_MAX_PATH,IniPath);

		//ʐMx
		int iBaudRate=GetPrivateProfileInt(strSectionName,_T("BaudRate"),9600,IniPath);

		//peB
		BYTE cParity;
		switch(GetPrivateProfileInt(strSectionName,_T("Parity"),0,IniPath)){
		case 0:cParity=NOPARITY;break;		//peB
		case 1:cParity=EVENPARITY;break;	//peB
		case 2:cParity=MARKPARITY;break;	//}[NpeB
		case 3:cParity=ODDPARITY;break;		//peB
		case 4:cParity=SPACEPARITY;break;	//󔒃peB
		default:cParity=NOPARITY;break;
		}

		//Xgbvrbg
		BYTE cStopBits;
		switch(GetPrivateProfileInt(strSectionName,_T("StopBits"),0,IniPath)){
		case 0:cStopBits=ONESTOPBIT;break;		//1stopbit
		case 1:cStopBits=ONE5STOPBITS;break;	//1.5stopbits
		case 2:cStopBits=TWOSTOPBITS;break;		//2stopbits
		default:cStopBits=ONESTOPBIT;break;
		}
		//|[gI[v
		if(!m_PortArray[i]->Init(szPortName,iBaudRate,cParity,cStopBits)){
			Finish();
			return false;
		}
	}
	return true;
}

//I
bool CCommManager::Finish()
{
	for(unsigned int i=0;i<m_PortArray.size();i++){
		delete m_PortArray[i];
	}
	m_PortArray.clear();
	return true;
}

//oCg񑗐M
bool CCommManager::SendData(unsigned int uPort,LPCBYTE lpByte,DWORD dwSize)
{
	if(uPort>=m_PortArray.size()){
		UtilErrorMessage(NULL,CString(MAKEINTRESOURCE(IDS_ERROR_SENDPORT)));
		return false;
	}

	//M
	return m_PortArray[uPort]->SendData(lpByte,dwSize);
}

LPCTSTR CCommManager::GetPortName(unsigned int uPort)
{
	if(uPort>=m_PortArray.size()){
		return NULL;
	}
	return m_PortArray[uPort]->GetPortName();
}

int CCommManager::GetBaudRate(unsigned int uPort)
{
	if(uPort>=m_PortArray.size()){
		return 0;
	}
	return m_PortArray[uPort]->GetBaudRate();
}

BYTE CCommManager::GetParityMode(unsigned int uPort)
{
	if(uPort>=m_PortArray.size()){
		return -1;
	}
	return m_PortArray[uPort]->GetParityMode();
}

BYTE CCommManager::GetStopBits(unsigned int uPort)
{
	if(uPort>=m_PortArray.size()){
		return -1;
	}
	return m_PortArray[uPort]->GetStopBits();
}
