#pragma once
#include "../common.h"
#include <hash_map>

typedef std::pair<unsigned int,std::vector<BYTE> > BYTE_STREAM;
typedef std::hash_map<std::string,BYTE_STREAM>::iterator COMMAND_MAP_ITERATOR;

class CCommandList{
protected:
	std::hash_map<std::string,BYTE_STREAM> Map_CommandName;
	virtual bool AddCommandItem(const std::string &CommandName,unsigned int,std::vector<BYTE>& ByteStream);
public:
	CCommandList();
	virtual ~CCommandList();
	virtual bool IsEmpty(){return Map_CommandName.empty();}
	virtual bool GetByteStream(const std::string&,unsigned int&,LPCBYTE&,DWORD&);

	virtual bool ReadFromFile();

	virtual void GetIterator(COMMAND_MAP_ITERATOR &begin,COMMAND_MAP_ITERATOR &end);
	virtual void Clear();
};
