#include "common.h"
#include "eventitem.h"
#include "../util.h"

CEventItem::CEventItem(DWORD timecode,LPCTSTR lpEvNam,unsigned int uPort,LPCBYTE lpB,DWORD dwbl)
	:m_dwTimeCode(timecode),
	m_strEventName(lpEvNam),
	m_lpByteStream(lpB),
	m_dwByteStreamLength(dwbl),
	m_uOutputPort(uPort),
	m_Status(EVENTITEM_STANDBY)
{
}


bool CEventItem::SendEvent()
{
	bool bDone=false;

	if(m_uOutputPort==EXTERNAL_EXEC_COMMAND_PORT){
		//OR}h
		std::string cmdline(m_lpByteStream,m_lpByteStream+m_dwByteStreamLength);

		PROCESS_INFORMATION pi={0};
		STARTUPINFO si={0};
		si.cb=sizeof(si);

		TCHAR *Buffer=new TCHAR[cmdline.length()+1];
		_tcsncpy(Buffer,cmdline.c_str(),cmdline.length());
		Buffer[cmdline.length()]=_T('\0');
		bDone=FALSE!=CreateProcess(NULL,Buffer,NULL,NULL,FALSE,NORMAL_PRIORITY_CLASS,NULL,NULL,&si,&pi);
		delete [] Buffer;
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
	}else if(m_uOutputPort==EXTERNAL_OPEN_COMMAND_PORT){
		//Ot@C֘AtŊJ
		std::string cmdline(m_lpByteStream,m_lpByteStream+m_dwByteStreamLength);

		bDone=(32<(int)ShellExecute(NULL,NULL,cmdline.c_str(),NULL,NULL,SW_SHOWNORMAL));
	}
	else{
		bDone=CCommManager::GetInstance().SendData(m_uOutputPort,m_lpByteStream,m_dwByteStreamLength);
	}
	m_Status=bDone?EVENTITEM_DONE:EVENTITEM_FAILED;
	return bDone;
}

LPCTSTR CEventItem::GetPortName()
{
	if(m_uOutputPort==EXTERNAL_EXEC_COMMAND_PORT){
		//OR}h
		return _T("Exec");
	}
	else if(m_uOutputPort==EXTERNAL_OPEN_COMMAND_PORT){
		return _T("Open");
	}
	else{
		return CCommManager::GetInstance().GetPortName(m_uOutputPort);
	}
}
