#include "common.h"
#include "util.h"
#include "resource.h"

#if defined(_DEBUG) || defined(DEBUG)

void UtilOutputDebugString( LPCSTR pszFormat, ...)
{
	va_list	argp;
	TCHAR pszBuf[512];
	va_start(argp, pszFormat);
	vsprintf( pszBuf, pszFormat, argp);
	va_end(argp);
	OutputDebugString( pszBuf);
}

void TraceLastError()
{
	LPVOID lpMsgBuf;
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL, GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ftHg
		(LPTSTR)&lpMsgBuf, 0, NULL);
	TRACE("API Error : %s",lpMsgBuf);
	LocalFree(lpMsgBuf);
}

#endif

void UtilErrorMessage(HWND hWnd,LPCTSTR msg)
{
	MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);

	TRACE(msg);
	TRACE("\n");
}

